;       Last change    August 1993
(in-package color)

(defun print-color (color)
  (print-line  color 
		 #\tab "Purity: (" (getp color 'PURITY-MIN) ","
				   (getp color 'PURITY-MAX) ")"
		 #\tab "Dilution: (" (getp color 'DILUTION-MIN) ","
				     (getp color 'DILUTION-MAX) ")"
		 #\tab "Hue: (" (getp color 'HUE-MIN) ","
				(getp color 'HUE-MAX) ")"
		 )
  )

(defun list-colors (&optional cs )
  (cond (cs
	 ; print first 5 colors on new line, continue rest on another
	 (print-line)
	 (do ((i 1 (+ i 1)))
	     ((or (> i 8) (null cs)))
	     (print-it (car cs) " ")
	     (setq cs (cdr cs)))
	 (when cs (list-colors cs))
	 )
	(t (print-line "Known colors: ")
	   (list-colors *known-colors*)
	   ))
  )

(set-display-function 'epilog::color-info 'color-info
  "Displays color information - purity, dilution and hue")
(set-display-function 'epilog::colors 'color-info
  "Displays color information - purity, dilution and hue")

(defun color-info (brief &rest args &aux
			 (c (car args)))
  (if (setq c (find-symbol (symbol-name c) 'color))
      (print-color c)
      (if brief
	  (list-colors)
	  (mapcar 'print-color *known-colors*))
      )
  )

