;       Last change    August 1993
(in-package user)
(eval-when (compile load eval)   
(provide 'epilib)
(require 'lib "epilog:lib;lib")
(defpackage epilib 
  (:use user lisp #+lucid lucid-common-lisp #-lucid common-lisp lib);#+excl excl lib)
  (:export
          term-type pred-type op-type wff-type entity-type quant-type
          operator-result operator-args operator-type 
	  neg-p wff-p pred-p term-p operator-p quantifier-p function-p
	  epi-variable-p function-term-p record-p quoted-expression-p 
	  quasi-quoted-expression-p is-quasi-quoted-expression epi-variable
	  type-pred-p skolem-constant-p lambda-pred-p type-lit-p
	  print-info prop-pred prop-args is-negated
	  logical-conn episodic-conn causal-conn is-lambda-pred is-lambda-expr
	  is-pred is-function is-variable is-function-term 
	  is-quoted-expression is-record is-wff is-operator is-quantifier
	  type-of-concept record-contents new-record 

	  *sorts* *solutions* *quoted-indicators* *record-indicators*
	  *simplification-schemas*

	  *environment* make-environment environment-main-net
	  environment-topic-net environment-specialist-info
	  environment-use-environments

	  ; Predefined quantifiers
	  L A E most many some few none WH The E!

	  ; Predefined predicates
	  ~> <=> implies and or because cause-of ** * @ _ true member-of 
	  part-of member-of-0 $ => <= >= -> less-than greater-than lt= gt=

	  ; Predefined comparison and evaluation results
          yes no unknown inconsistent
	  disjoint contains overlaps subsumes subsumed equivalent 

	  ; Variable and constant symbols
	  C X Y Z U V W

	  ; Entity types and properties
	  wff pred operator quantifier op quant term meta-entity entity
	  lambda function quoted-expression record indef variable
	  quasi-quoted-expression parents quote-wff
	  indicators specialists result args arguments predicate constant 
	  main restrict conditional equivalence subject object iobj
	  meaning-postulate assumption negated sort main-sort print
	  skol-const matchable 
	  prefix quantified modified episodic causal logical 
	  +trigger -trigger +keys -keys +other -other lit-classes
	  controlled-vars
	  wh-vars e-vars simplification-schema

	  ; Predefined sorts
	  episode ep event number num propos prop integer int real set
	  time string str 

	  define-sort find-sort quantifier-prob var-present
	  number-arg non-constant-arg constant-arg check-constant
	  get-min get-max get-super get-sub get-all-super get-all-sub get-id
	  question combine-subgoal -sub -super

	  ; Normalization
	  normalize normalize-term normalize-pred normalize-op normalize-wff
	  negate make-variable
	  *name-symbol* ! *default-indicators* 
	  *expand-names* 
	  splittable skolemizable skolemize split
	  *wh-pattern* *e-pattern* *meta* *qa-mode* *meaning-postulate* 
	  *simplification-schema*
	  *normed-subs* *skol-subs* *normed-prob* *new-vars*
	  *stop-if-error* *split-episodic*
	  add-sort add-function add-predicate add-quantifier add-operator
	  add-operator-type *interim*
	  input-index

	  ; Predicate splitting
	  *check-pred-parts* pred-info split-pred pred-parts

	  ; Predefined operator types
	  wff-op pred-op term-op quantifier-op operator-op term-forming-op

	  ; Predefined Operators
	  not ~ nec poss prob almost sort-of very plural plur coll coll-of
	  K K1 to that whether answer-to adv-s adv-a adv-e adv-dest ly adv-p
	  adv-f na adv-q
	  nearly mos extremely severely attr nn member-type-of Ke Ka YN-Q
	  qquote qq
	  pres futr perf prog box perhaps past

	  ; Predefined Functions
	  pair set-of-all set-of cardinality-of 
	  start-of end-of date F

	  ; Probabilities
	  calc-prob-list combine-probs calc-prob get-prob
	  combine-contradict-probs combine-support-probs recalc-probs
	  recalc-prob c-prob

	  ; Memory
	  *insertion* *input-array-expansion-size* *memory-load-specs*
	  new-symbol save-info write-perm-memory read-perm-memory temp-cleanup
	  make-fn-arg new-index add-to-input-array rpm wpm 

	  ; Specialists
	  function-eval interested-party spec-entry spec-test 
	  spec-assert spec-int spec-enter spec-eval
	  *maximum-effort* *specialist-entry-effort* *specialist-eval-effort*
	  *spec-evaluate* *spec-enter* *spec-assert* *fwd-spec-compare*
	  *spec-compare-lits* *spec-compare-preds* *spec-eval-fn*
	  *assertions* *spec-simplify* *spec-assumptions*
	  *current-netname* *current-literal* *flattened-lit*
	  *active-specialists* *available-specialists* 
	  create-predicate create-function create-operator
	  function-with-rel-pred  rel-pred
	  *fn-simplified*
	  avail-specs active-specs specs
	  other-function other-predicate other-entry-rtn entry-rtn

	  ; Predefined (expected) specialists
	  episode-specialist type-specialist part-specialist 
	  other-specialist meta-specialist hier-specialist

	  ; Unification & Comparison
	  *fix-unify* compare-cleanup *unify-sorts*
	  compare-wffs compare-arglists compatible incompatible
	  make-comparison-info 
	  comparison-info-wff1 comparison-info-wff2 
	  comparison-info-lit1 comparison-info-lit2 
	  comparison-info-subs1 comparison-info-subs2 
	  comparison-info-residue1 comparison-info-residue2 
	  compare-predicates compatible-sorts
	  spec-compare-preds spec-compatible-lits spec-incompatible-lits

	  ; Substitution
	  *subst-prob* make-prop substitute-prop 
	  substitute-term print-trace-subs print-subs
	  arg-sub-list make-sub-element

	  ; Retrieval
	  wffs wffs-by-topic
	  get-class retrieve ret get-everything gimme
	  show-everything display-node node instance-type description content
	  get-content show-input-array input-array input formula 
	  print-wff-type pr-formula pr-prob

	  ; Hierarchies
	  *hierarchies* *all-hierarchies* part-type 
	  add-hier set-hier-type add-topic add-indicate number-hier hier-rel 
	  print-hier hier-test add-sort-to-hier add-part-hier
	  *remainder-indicators* hier-property remainder other rest

	  ;Hierarchy properties
	  exclusion overlap part parts hier-type hier properties exhaustive
	  non-exhaustive normal-level

	  part-hier part-type-hier pred-hier root total bounds
	  min max sub super hier-change
	  compare-hier-res

	  ;Familiar parts
	  *familiar-parts* familiar-parts familiar
	  head face ear eye nose mouth tongue tooth neck torso leg arm wing tail
	  finger toe knee elbow flipper fin body wrist ankle abdomen chest back 
	  trunk brain skull 
	  *part-hierarchy-types* form state 

	  ; Interest
	  *operator-component* *arg-component* *wff-component* 
	  *interest-threshold* *check-inherit* *inherit-amount* *initial-charge*
	  *back-up-interest* *deep-thought* *minimum-interest* 
	  *maximum-interest* *qa-inherit-amount*
	  wff-interest pred-interest set-interest interest check-interest
	  add-interest change-interest about inherit-int inherit-calc
	  episodic-lit useful-nonepisodic-lit

	  ; Complexity
	  *literal-complexity* *variable-complexity* *constant-complexity*
	  *function-complexity* set-complexity wff-complexity
	  complexity

	  ; Classification
	  *key-threshold* *useful-nonepisodic-topics*
	  *subnet-topics* 
	  *intermediate-class* *save-class* *save-intermediate* 
	  class entry-class keys classify mp-classify grab-types 
	  extract-type super-class sub-class instances sort-classes
	  order-types order-instances
	  class-cleanup classify-and-store topical-class add-flags
	  subnet-pred equivalent-items equiv-classes

	  ; Predefined topics
	  tp.type tp.spec tp.content tp.description tp.mental-attitude
	  tp.role tp.mental-attitude-object tp.topics tp.unknown
	  tp.causal-relationship tp.kinship tp.happening tp.location

	  ; Equivalence sets
	  save-equivalence get-equivalence

	  ))
(unless (find-package 'epilib) (make-package 'epilib)))
(in-package epilib)
(load "epilog:epilib;info")
(load "epilog:epilib;spec")
(load "epilog:epilib;prob")
(load "epilog:epilib;pred")
(load "epilog:epilib;hier")
(load "epilog:epilib;create")
(load "epilog:epilib;objects")
(load "epilog:epilib;mem")
(load "epilog:epilib;subst")
(load "epilog:epilib;interest")
(load "epilog:epilib;complex")
(load "epilog:epilib;class")
(load "epilog:epilib;norm")
(load "epilog:epilib;ret")
(load "epilog:epilib;unify")
(load "epilog:epilib;compare")

