;       Last change    August 1993
(in-package equal)   


(set-display-function 'epilog::equality-info 'equality-info 
  "Displays information about equality")
(set-display-function 'epilog::equal-info 'equality-info 
  "Displays information about equality")

(defun print-equality-set (brief node &optional name)
  (declare (ignore brief))
  (unless (null node)
  (cond (name
	 (print-line (print-info name) #\tab 
		     (if (member 'equivalence (episet-properties node)) 
			 "Equivalent to " 
			 "Not equal to "))
	 (print-it (mapcar 'print-info 
			   (remove-if #'+equal (episet-contents node)))))
	(t (print-line "Equivalence Set: ")
	 (print-it (mapcar 'print-info 
			   (remove-if #'+equal (episet-contents node)))))
	))
  )

(defun print-equality (brief net item &aux
			     (eq (findset net (equiv-set-name item)))
			     (noneq (findset net (non-equal-set-name item))))
  (when eq (print-equality-set brief eq item))
  (when noneq (print-equality-set brief noneq item))
  )

(defun print-equality-s (brief st)
  (maphash #'(lambda (key node) 
	             (declare (ignore key))
		     (if (and node (member 'equivalence (episet-properties node)))
			 (print-equality-set brief node))) st)
)

(defun print-net (context &aux
			  (usec context))
  (if (null context)
      (setq usec '/))
  (let ((context-array (retrieve-specialist-info *environment*
						 'set-equal::set-equal)))
    (if (null context-array)
	nil
      (gethash usec context-array))))

(defun equality-info (brief &rest args &aux 
		       (item (car args))
		       (context (cadr args))
		       (net (print-net context)))
  (when (not (null net))
	(if (or (null item)
		(equal item 'epilog::all))
	    (let ()
	         (print-line "Equality Information for Context" #\tab 
			    (if (null context) '/ context))
                 (print-equality-s brief (episet-subnet-sets net))
		 )
	    (print-equality brief net item)
	    ))
  )

