;       Last change    August 1993
(in-package response)

(defvar *tense* nil)

(defun prepare-print (frag &optional short &aux ftype s p ans sp vp spart pp
			   v va np 
			   (oldt *tense*))
  (setq ans
    (cond ((null frag) nil)
	  ((not (symbolp frag)) (prepare-lex frag))
	  ((and (fragment-name frag) (not short)
		(member (fragment-fragtype frag) '(S NP))
		(not (fragment-negated frag))
		(if (equal (fragment-fragtype frag) 'S)
		    (fragment-head frag) t)
		(setq s (car (member frag *said* :test 'same-name)))
		(not (getp (fragment-head frag) 'parts))
		(if (equal (fragment-fragtype frag) 'NP)
		    (or (fragment-subject frag)
			(and (equal (fragment-fragtype s) 'S) 
			     (not (fragment-vp frag))
			     (parent-of frag s)
			     )
					; object of verb other than be
			(not (and (setq vp (fragment-head frag))
				  (member (fragment-fragtype vp) '(VP RelC))
				  (member (fragment-verb vp) '(be has)))))
		  t))
					; say short version - shorter NP or pronoun
	   (print-short frag s)
	   )
	  ((getp frag 'print)
	   (append (prepare-lex (getp frag 'adv)) (list (getp frag 'print))))
	  ((null (setq ftype (getp frag 'frag-type)))
	   (prepare-lex frag))
	  ((setq p (getp frag 'parts))
	   (if (and (equal (fragment-fragtype frag) 'S)
		    (equal (find-sort (fragment-name frag)) 'episode)
		    (not (epi-variable (fragment-name frag))))
	       (setq *tense* 'past))
	   (let* ((as (remove-if 'null (mapcar 'prepare-print p)))
		  (pr (append (prepare-lex (getp frag 'pre)) 
			      (if (fragment-negated frag) (list "not"))
			      (prepare-lex (getp frag 'adv))
			      (car as))))
	     (setq as (cdr as))
	     (do ((n (car as) (car as)))
		 ((null as))
	       (setq as (cdr as))
	       (when (or (member (fragment-fragtype frag) '(S))
			 (> (list-length p) 2))
		 (setq pr (append pr (list '","))))
	       (when (and (null as) 
			  (if (equal (getp frag 'conj) 'and)
			      (not (member (fragment-fragtype frag)
					   '(ADVP)))
			    t))
		 (setq pr (append pr (prepare-lex (getp frag 'conj)))))
	       (setq pr (append pr n))
	       )
	     pr))
	  (t
	   (case ftype
	       (S			; AdVS NP VP ADVP 
		(if (equal (fragment-name frag)
			   (fragment-name (fragment-NP frag)))
		    (setp frag 'name nil))
		(check-there frag)
		(unless (or (null (fragment-name frag))
			    (equal (fragment-name frag) 'removed))
		  (if (and (equal (find-sort (fragment-name frag)) 'episode)
			   (not (epi-variable (fragment-name frag))))
		      (setq *tense* 'past))
		  (update-said (fragment-name frag) frag)
		  (pushnew frag *current-sentence* :test 'same-name) )
		(setq np (fragment-NP frag))
		(setq vp (fragment-VP frag))
		(decide-number np)
		(cond ((and (not (noun-info np))
			    (equal (fragment-aspect vp) 'prespart))
		       (setq spart nil))
		      (t (setq spart (prepare-print np))))
		(agree-number np vp)
		(setq spart (append spart (prepare-print vp)))
		(when (and (fragment-advp frag) (null spart))
		  (setp (fragment-advp frag) 'prep nil)
		  (setp (fragment-advp frag) 'pre nil))
		(append (unless short (prepare-print (fragment-advs frag)))
			spart
			(unless short (prepare-print (fragment-advp frag)))
			))
	       (NP			; det AP noun/proper-noun PP RelC
		(unless (or (if (fragment-S frag)
				(if (fragment-noun frag)
				    (fragment-VP (fragment-S frag))
				  t))
			    (fragment-parts frag)
			    (null (fragment-name frag))
			    (equal (fragment-name frag) 'removed))
		  (update-said (fragment-name frag) frag)
					; (pushnew frag *said* :test 'same-name) 
		  (pushnew frag *current-sentence* :test 'same-name) )
		(setq sp (getp frag 'S))
		(cond ((and sp 
			    (if (fragment-noun frag)
				(fragment-VP sp)
			      t)
			    (setq s (prepare-print (getp frag 'S))))
		       (append (prepare-lex (getp frag 'pre)) s))
		      ((prepare-lex (getp frag 'pronoun)))
		      ((or (fragment-AP frag) (fragment-PP frag)
			   (fragment-RELC frag) (fragment-noun frag))
		       (decide-number frag) 
		       (decide-determiner frag) 
		       (if (and (setq pp (fragment-PP frag))
				(handle-poss frag pp))
			   (setp frag 'PP nil))
		       (when (fragment-Relc frag)
			 (agree-number frag (fragment-relc frag)))
		       (append
			(prepare-lex (getp frag 'adv))
			(if (fragment-negated frag) (list "not"))
			(prepare-lex (getp frag 'determiner))
			(prepare-print (getp frag 'AP))
			(unless (or (getp frag 'noun)
				    (if (not (fragment-subject frag))
					(equal (find-verb (fragment-head frag)) 'be)
				      ))
			  (prepare-lex (getp frag 'proper-noun)))
			(prepare-noun (getp frag 'noun)
				      (getp frag 'number))
			(prepare-print (getp frag 'PP))
			(if (getp frag 'Relc) 
			    (append (list (decide-that frag))
				    (prepare-print (getp frag 'RelC))
				    ))
			(if (and sp (fragment-advp sp))
			    (prepare-print (getp sp 'advp)))
			))
		      ((prepare-lex (getp frag 'proper-noun)))
		      ))
	       ((VP RelC)		; adv verb objects
		(setq v (prepare-verb (getp frag 'verb)
				      (getp frag 'number)
				      (cond ((getp frag 'tense))
					    (t *tense*))
				      (getp frag 'aspect)
				      (getp frag 'negated)
				      (getp frag 'mood)))
		(if (fragment-negated frag) (setq *already-neg* t))
		(if (equal (getp frag 'verb) 'be)
		    (setq va (append v (prepare-lex (getp frag 'adv))))
		  (setq va (append (prepare-lex (getp frag 'adv)) v)) )
		(append (if (equal ftype 'RelC) 
			    (prepare-lex (getp frag 'who)))
			va
			(prepare-lex (getp frag 'particles))
			(apply 'append 
			       (mapcar 'prepare-print (getp frag 'objects)))
			(unless short (prepare-print (getp frag 'ADVP)))
			))
	       (AP			; adv adj
		(append (if (fragment-negated frag) (list "not"))
			(prepare-lex (getp frag 'adv))
			(prepare-lex (getp frag 'adj)))
		)
	       ((PP ADVP)		; pre prep NP or S
		(let ((item (cond ((prepare-print (getp frag 'NP)))
				  (t (prepare-print (getp frag 'S))))))
		  (when (and item
			     (not (and (or (equal ftype 'ADVP)
					   (equal (fragment-fragtype (fragment-head (fragment-head frag))) 'ADVP))
				       (or (equal item '("a" "event"))
					   (equal item '("it"))
					   (equal item '("events")))
				       )))
		    (setq item (append (if (fragment-negated frag) (list "not"))
				       (prepare-lex (getp frag 'pre))
				       (prepare-lex (getp frag 'prep))
				       item))
					; problem with "pair" sometimes
		    (if (and (equal (car item) "of")
			     (equal (cadr item) "is"))
			(setq item nil))
		    item)
		  ))
	       (AdVS			; adv or adv NP or adv S
		(append (if (fragment-negated frag) (list "not"))
			(prepare-lex (getp frag 'adv))
			(cond ((prepare-print (getp frag 'NP)))
			      (t (prepare-print (getp frag 'S))))
			))
	       )
	     )
	  ))
  (setq *tense* oldt)
  ans)

(defun decide-that (frag)
  ; inanimate objects, animals etc, get that
  ; people get who
  (cond ((or (check-noun-property (fragment-noun frag) 'masculine)
	     (check-noun-property (fragment-noun frag) 'feminine))
	"who")
	((and (fragment-proper-noun frag)
	      (member (get-pronoun (fragment-name frag) t) '("he" "she")))
	 "who")
	(t "that"))
  )


(defun same-name (frag1 frag2)
  (equal (fragment-name frag1) (fragment-name frag2)))

(defun print-short (frag s &aux res)
  (add-number (fragment-number s) frag t)
  (setq res (decide-pronoun frag s))
  (if (or (null res) (ambiguous-pronoun frag res s))
      (setq res (decide-short frag s)))
  (if (and res (not (listp res)))
      (setq res (list res)))
  (pushnew frag *current-sentence* :test 'same-name)
  (if (or res 
	  (and (equal (fragment-fragtype frag) 'S)
	       (equal (fragment-fragtype (fragment-head frag)) 'ADVP)))
	  res (prepare-print frag t))
  )

(defun prepare-lex (item)
  (cond ((null item) nil)
	((listp item) 
	 (mapcar #'(lambda (a) (if (stringp a) a
			       (string-downcase (princ-to-string a)))) item))
	((stringp item) (list item))
	(t (list (string-downcase (princ-to-string item)))) ))

; s-print prints each word in a sentence, adding the appropriate spaces, and
; a period at the end.

(defun s-print (slist)
  (print-line)
  (dolist (s slist) 
	  (unless (member s (list "," "") :test #'equal) (print-it " "))
	  (print-it s))
  (print-it ".")
 )

; vowel returns t if a word begins with a vowel, nil otherwise

(defun vowel (word)
  (if word
      (if (member (aref word 0) '(#\a #\e #\i #\o #\u) :test #'equal)
	  t
	  nil)
      nil)
  )

; combine-words looks for specific word combinations and replaces them by a
; single word

(defun combine-words (nlist &aux
			    (first (car nlist))
			    (next (cadr nlist)))
  (cond ((null first) nil)
	((null next) (list first))

	;no thing/person => nobody/nothing
	;some thing/person => someone/something
	;any thing/person => anyone/anything
	;every thing/person => everyone/everything
	(t (cond ((and (member first (list "no" "some" "any" "every") 
			       :test #'equal)
		       (member next (list "thing" "person" "human") :test #'equal))
		  (if (equal next "thing") 
		  (append (list 
			   (cond ((equal first "no") "nothing")
				 ((equal first "some") "something")
				 ((equal first "any") "anything")
				 ((equal first "every") "everything")))
			  (combine-words (cddr nlist)))
		  (append (list 
			   (cond ((equal first "no") "nobody")
				 ((equal first "some") "someone")
				 ((equal first "any") "anyone")
				 ((equal first "every") "everyone")))
			  (combine-words (cddr nlist)))))

		 ; a followed by word beginning with a vowel => an
		 ((and (member first '("a" "A") :test 'equal)
		       (vowel next))
		  (append (if (equal first "a")
			      (list "an") (list "An"))
			  (combine-words (cdr nlist))))

		 (t (append (list first) (combine-words (cdr nlist))))
		 ))
	)
  )

(defun remove-header-nulls (nlist)
  (cond ((null nlist) nil)
	((equal (car nlist) "") (remove-header-nulls (cdr nlist)))
	(t nlist)))

; post-proc goes through the final list of words and combines some
; combinations and fixes up the artical a before a vowel
; It also capitalizes the first word.

(defun post-proc (alist &aux
			nlist first)
  (when alist
  ; combine all incidences of "no" "thing" to "nothing"
  ;                           "every" "thing" to "everything"
  ;                           "any" "thing" to "anything"
  ;                           "some" "thing" to "something"
  ;                           "no" "person" to "nobody"
  ;                           "some" "person" to "someone"
  ;                           "any" "person" to "anyone"
  ;                           "every" "person" to "everyone"
  ; replace "a" followed by word beginning with vowel to "an"
  (setq nlist (combine-words alist)))

  (setq nlist (remove-header-nulls nlist))
  (when nlist
  ; Capitalize 1st word
  (if (stringp (car nlist))
      (setq first (string-upcase (car nlist) :start 0 :end 1))
      (setq first (car nlist)))
  (append (list first) (cdr nlist)))
  )

; print-it-first prints the first sentence of a group of answer sentences.
; It prepends the answer and a comma to the sentence before printing.

(defun print-it-first (sentence &aux answer a)
  (setq *said* nil)
  (setq *current-sentence* nil)
  (setq *first* t)
  (setq answer (prepare-print sentence))
  ; go thru sentence tree, printing
  (setq answer (append (if (and (setq a (print-answer *answer*))
				(not (equal a "")))
			   (list (print-answer *answer*) ",")) answer))
  (s-print (post-proc answer))
  )

; print-and prints any other sentences in a group

(defun print-and (sentence &aux answer)
  (setq *said* (remove-if #'(lambda (a) (epi-variable (fragment-name a))) *said*))
  (setq *current-sentence* nil)
  (setq answer (prepare-print sentence))
  ; go thru sentence tree, printing
  (s-print (post-proc answer)) 
  )

; print-answer returns the string for the answer

(defun print-answer (answer)
  (cond ((equal answer 'YES)
	 "Yes")
	((equal answer 'NO)
	 "No")
	((equal answer 'UNKNOWN)
	 "Unknown")
	(t "") ;answer
	)
  )

(defun prepare-noun (noun number)
  (when noun (list (determine-noun noun number)))
  )

(defun prepare-verb (verb number tense aspect negp &optional mood)
  (when verb
    (list (determine-verb tense verb number negp aspect mood)))
  )

; decide short is to be used to provide a definite noun phrase when a
; pronoun would be too ambiguous
; argfrag is the curent fragment we are looking at, samefrag is the previously
; occurring fragment of the same name

(defun decide-short (argfrag &optional (samefrag argfrag) &aux pr det h v)
  (cond ((fragment-print samefrag))
	((equal (fragment-fragtype samefrag) 'S)
	 (if (not (member samefrag *current-sentence* :test 'same-name))
	     (if (or (equal (fragment-aspect argfrag) 'prespart)
		     (and (setq v (fragment-vp argfrag))
			  (equal (fragment-aspect v) 'prespart))
		     (and (equal (fragment-fragtype argfrag) 'NP)
		      (not (and (setq h (fragment-head argfrag))
				(or (equal (fragment-fragtype h) 'advp)
				    (and (equal (fragment-fragtype h) 'pp)
					 (equal (fragment-prep h) 'as)))
				    )) ) )
		 (prepare-print (copy-to-new-NP samefrag) t)
		 (prepare-print samefrag t))
	     ) )
	((and (fragment-proper-noun samefrag)
	      (symbolp (fragment-name samefrag))
	      (getp (fragment-name samefrag) 'trans))
	 (fragment-proper-noun samefrag))
	((setq pr (fragment-parts samefrag) )
	 (decide-short (car pr) (car pr)))
	((and (check-noun-property (fragment-noun samefrag) 'group)
	      (fragment-pp samefrag)
	      (or (equal (fragment-prep (fragment-pp samefrag)) 'of)
		  (and (null (fragment-prep (fragment-pp samefrag)))
		       (or (member samefrag *mod-frags*)
			   (member argfrag *mod-frags*))))
	      (if (setq h (fragment-head argfrag))
	          (and (equal (fragment-fragtype h) 'PP)
		       (equal (fragment-prep h) 'of)
		       (equal (fragment-pre h) 'full) ) )
	      )
	 (decide-short argfrag (fragment-np (fragment-pp samefrag)))
	 )
	((and (check-noun-property (fragment-noun samefrag) 'member)
	      (fragment-pp samefrag)
	      (not (equal samefrag argfrag))
	      (equal (fragment-prep (fragment-pp samefrag)) 'of))
	 (decide-short argfrag argfrag))
	((fragment-noun samefrag) 
	 ; decide on determiner
	 (setq det 
	       (cond ((equal (fragment-determiner samefrag) "another")
		      (if (fragment-subject argfrag) "the other" "that other"))
		     ((equal (fragment-determiner samefrag) "yet another")
		      (if (fragment-subject argfrag) "the last" "that last"))
		     ((equal (fragment-determiner samefrag) "other") 
		      "the other")
		     ((equal (fragment-determiner samefrag) "even more")
		      "those last")
		     (t "the")))
	 ; if Ap present and necessary, use it too
	 (append (list det) 
		 (if (and (fragment-AP samefrag) 
			  (member (fragment-determiner samefrag)
			       '("another" "yet another" "other" "even more")))
		     (prepare-print (fragment-AP samefrag) t)) 
		 (prepare-noun (getp samefrag 'noun) (getp samefrag 'number))
		 (if (and (fragment-pp samefrag) (equal (fragment-prep (fragment-pp samefrag)) 'of))
		     (prepare-print (fragment-PP samefrag) t)))
	 )
	(t (prepare-print argfrag t))
	)
  )
