;       Last change    August 1993
(in-package user)
(eval-when (compile load eval)   
(provide 'set-specialist)
(require 'epilib "epilog:epilib;epilib")
(require 'spec "epilog:spec;spec")
(require 'set-equal 
    "epilog:set-equal;set-equal")
(defpackage set-specialist (:nicknames set) 
  (:use lisp user spec lib epilib set-equal)
  (:export
	  ;; Functions for the specialist interface

	  enter evaluate incompatible-lits compatible-lits

	  ;; functions which may be used in propositions

	  set-of cardinality-of

	  ))
(unless (find-package 'set) (make-package 'set)))
(in-package set)


;(ns-declare 'epilog::sort 'epilog::set)

(traceable 'epilog::set-entry "Traces input of set information") 
(traceable 'epilog::set-assert "Traces assertions made by set specialist") 
(traceable 'epilog::set-eval "Traces evaluation of set information") 
(traceable 'epilog::set-test "Traces comparison of set literals") 
(traceable 'epilog::set-function-eval "Traces evaluation of set functions") 
(traceable 'epilog::set-all "Traces everything about sets"
           '(epilog::set-entry epilog::set-eval epilog::set-test 
	     epilog::set-assert epilog::set-function-eval))
(traceable 'epilog::set-min "Traces interesting things about sets"
           '(epilog::set-entry epilog::set-eval epilog::set-test 
	     epilog::set-assert epilog::set-function-eval))

; make sure these are all interned into the set package

(defconstant set-preds
  '(equal member-of member-of-0 subset-of has-cardinality))
(defconstant set-ops
  '(plur plural coll set-of-all))

(load "epilog:set;functions")
(load "epilog:set;eval")
(load "epilog:set;enter")
(load "epilog:set;print")
(load "epilog:set;compare")
